<?php
namespace Folha\Entities;

use HCM\Util\DateUtil;

class MigComunicaparc extends Base\MigComunicaparc
{

	/**
     * @param $nrparcnegocio
     * @throws \Exception
     * @return MigComunicaparc
     */
    public function setNrparcnegocio ($nrparcnegocio) {
        if (empty($nrparcnegocio)) {
            throw new \Exception("Campo Obrigatório: 'Nr. Parceiro Negócio'");
        }

        $this->nrparcnegocio = $nrparcnegocio;
    }

    /**
     * @param $cdformacomu
     * @throws \Exception
     * @return MigComunicaparc
     */
    public function setCdformacomu ($cdformacomu) {
    	if (empty($nrparcnegocio)) {
    		$cdformacomu = '01';	
    	}
        $this->cdformacomu = $cdformacomu;
    }

	/**
     * @param mixed $dtinclusao
     * @throws \Exception
     * @return MigComunicaparc|void
     */
    public function setDtinclusao($dtinclusao)
    {
        if (!preg_match("/\d{2}\/\d{2}\/\d{4}/", $dtinclusao)) {
            throw new \Exception("Data com formato inválido.");
        }

        if (!($dtinclusao instanceof \DateTime)) {
            $dtinclusao = DateUtil::getDataDeString($dtinclusao);
        }

        $this->dtinclusao = $dtinclusao;
    }

    /**
     * @param mixed $dtultatu
     * @return MigComunicaparc|void
     */
    public function setDtultatu($dtultatu)
    {
        if (!preg_match("/\d{2}\/\d{2}\/\d{4}/", $dtultatu)) {
            throw new \Exception("Data com formato inválido.");
        }

        if (!($dtultatu instanceof \DateTime)) {
            $dtultatu = DateUtil::getDataDeString($dtultatu);
        }

        $this->dtultatu = $dtultatu;
    }

}